/* smd.c */

#include "f103bsp.h"

/* 
  f103 step moter driver board 

  SMD0001 configuration
  1) ADC        ADC1    main power
  2) UART       UART1         
  3) CAN        master
  4) SPI        l6470PDTR
  5) GPIOs      
      - input: switch(3), other(1)
      - output: led(1)
*/

void GpioInit(void){
  
  GPIO_InitTypeDef  GPIO_InitStructure;
  
  /* Enable the GPIO_LED Clock */
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB, ENABLE);

  /* Configure the GPIO_LED pin */
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_9; /* Switch No.1 */
  
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPD;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_Init(GPIOB, &GPIO_InitStructure);
}

void LedInit(void){
  
  GPIO_InitTypeDef  GPIO_InitStructure;
  
  /* Enable the GPIO_LED Clock */
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB, ENABLE);

  /* Configure the GPIO_LED pin */
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_6;
  
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_Init(GPIOB, &GPIO_InitStructure);
}
void LedOn(void){ GPIOB->BRR = GPIO_Pin_6; }
void LedOff(void){ GPIOB->BSRR = GPIO_Pin_6; }
void LedToggle(void){ GPIOB->ODR ^= GPIO_Pin_6; }